Index: /pjproject/branches/symbian/pjlib/src/pjlib-test/ioq_perf.c
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pjlib-test/ioq_perf.c	(revision 787)
+++ /pjproject/branches/symbian/pjlib/src/pjlib-test/ioq_perf.c	(revision 788)
@@ -18,5 +18,10 @@
  */
 #include "test.h"
-#include <pjlib.h>
+#include <pj/errno.h>
+#include <pj/ioqueue.h>
+#include <pj/log.h>
+#include <pj/os.h>
+#include <pj/pool.h>
+#include <pj/sock.h>
 #include <pj/compat/high_precision.h>
 
@@ -73,5 +78,5 @@
                              pj_ssize_t bytes_read)
 {
-    test_item *item = pj_ioqueue_get_user_data(key);
+    test_item *item = (test_item*)pj_ioqueue_get_user_data(key);
     pj_status_t rc;
     int data_is_available = 1;
@@ -151,5 +156,5 @@
                               pj_ssize_t bytes_sent)
 {
-    test_item *item = pj_ioqueue_get_user_data(key);
+    test_item *item = (test_item*)pj_ioqueue_get_user_data(key);
     
     //TRACE_((THIS_FILE, "     write complete: sent = %d", bytes_sent));
@@ -189,5 +194,5 @@
 static int worker_thread(void *p)
 {
-    struct thread_arg *arg = p;
+    struct thread_arg *arg = (struct thread_arg *)p;
     const pj_time_val timeout = {0, 100};
     int rc;
@@ -250,6 +255,6 @@
         return -10;
 
-    items = pj_pool_alloc(pool, sockpair_cnt*sizeof(test_item));
-    thread = pj_pool_alloc(pool, thread_cnt*sizeof(pj_thread_t*));
+    items = (test_item *)pj_pool_alloc(pool, sockpair_cnt*sizeof(test_item));
+    thread = (pj_thread_t **)pj_pool_alloc(pool, thread_cnt*sizeof(pj_thread_t*));
 
     TRACE_((THIS_FILE, "     creating ioqueue.."));
@@ -266,6 +271,6 @@
         items[i].ioqueue = ioqueue;
         items[i].buffer_size = buffer_size;
-        items[i].outgoing_buffer = pj_pool_alloc(pool, buffer_size);
-        items[i].incoming_buffer = pj_pool_alloc(pool, buffer_size);
+        items[i].outgoing_buffer = (char*)pj_pool_alloc(pool, buffer_size);
+        items[i].incoming_buffer = (char*)pj_pool_alloc(pool, buffer_size);
         items[i].bytes_recv = items[i].bytes_sent = 0;
 
@@ -332,5 +337,5 @@
 	struct thread_arg *arg;
 
-	arg = pj_pool_zalloc(pool, sizeof(*arg));
+	arg = (struct thread_arg *)pj_pool_zalloc(pool, sizeof(*arg));
 	arg->id = i;
 	arg->ioqueue = ioqueue;
@@ -444,4 +449,9 @@
     enum { BUF_SIZE = 512 };
     int i, rc;
+    enum
+    {
+	SOCK_DGRAM = 1,
+	SOCK_STREAM = 2,
+    };
     struct {
         int         type;
@@ -451,47 +461,47 @@
     } test_param[] = 
     {
-        { PJ_SOCK_DGRAM, "udp", 1, 1},
-        { PJ_SOCK_DGRAM, "udp", 1, 2},
-        { PJ_SOCK_DGRAM, "udp", 1, 4},
-        { PJ_SOCK_DGRAM, "udp", 1, 8},
-        { PJ_SOCK_DGRAM, "udp", 2, 1},
-        { PJ_SOCK_DGRAM, "udp", 2, 2},
-        { PJ_SOCK_DGRAM, "udp", 2, 4},
-        { PJ_SOCK_DGRAM, "udp", 2, 8},
-        { PJ_SOCK_DGRAM, "udp", 4, 1},
-        { PJ_SOCK_DGRAM, "udp", 4, 2},
-        { PJ_SOCK_DGRAM, "udp", 4, 4},
-        { PJ_SOCK_DGRAM, "udp", 4, 8},
-        { PJ_SOCK_DGRAM, "udp", 4, 16},
-        { PJ_SOCK_STREAM, "tcp", 1, 1},
-        { PJ_SOCK_STREAM, "tcp", 1, 2},
-        { PJ_SOCK_STREAM, "tcp", 1, 4},
-        { PJ_SOCK_STREAM, "tcp", 1, 8},
-        { PJ_SOCK_STREAM, "tcp", 2, 1},
-        { PJ_SOCK_STREAM, "tcp", 2, 2},
-        { PJ_SOCK_STREAM, "tcp", 2, 4},
-        { PJ_SOCK_STREAM, "tcp", 2, 8},
-        { PJ_SOCK_STREAM, "tcp", 4, 1},
-        { PJ_SOCK_STREAM, "tcp", 4, 2},
-        { PJ_SOCK_STREAM, "tcp", 4, 4},
-        { PJ_SOCK_STREAM, "tcp", 4, 8},
-        { PJ_SOCK_STREAM, "tcp", 4, 16},
+        { SOCK_DGRAM, "udp", 1, 1},
+        { SOCK_DGRAM, "udp", 1, 2},
+        { SOCK_DGRAM, "udp", 1, 4},
+        { SOCK_DGRAM, "udp", 1, 8},
+        { SOCK_DGRAM, "udp", 2, 1},
+        { SOCK_DGRAM, "udp", 2, 2},
+        { SOCK_DGRAM, "udp", 2, 4},
+        { SOCK_DGRAM, "udp", 2, 8},
+        { SOCK_DGRAM, "udp", 4, 1},
+        { SOCK_DGRAM, "udp", 4, 2},
+        { SOCK_DGRAM, "udp", 4, 4},
+        { SOCK_DGRAM, "udp", 4, 8},
+        { SOCK_DGRAM, "udp", 4, 16},
+        { SOCK_STREAM, "tcp", 1, 1},
+        { SOCK_STREAM, "tcp", 1, 2},
+        { SOCK_STREAM, "tcp", 1, 4},
+        { SOCK_STREAM, "tcp", 1, 8},
+        { SOCK_STREAM, "tcp", 2, 1},
+        { SOCK_STREAM, "tcp", 2, 2},
+        { SOCK_STREAM, "tcp", 2, 4},
+        { SOCK_STREAM, "tcp", 2, 8},
+        { SOCK_STREAM, "tcp", 4, 1},
+        { SOCK_STREAM, "tcp", 4, 2},
+        { SOCK_STREAM, "tcp", 4, 4},
+        { SOCK_STREAM, "tcp", 4, 8},
+        { SOCK_STREAM, "tcp", 4, 16},
 /*
-	{ PJ_SOCK_DGRAM, "udp", 32, 1},
-	{ PJ_SOCK_DGRAM, "udp", 32, 1},
-	{ PJ_SOCK_DGRAM, "udp", 32, 1},
-	{ PJ_SOCK_DGRAM, "udp", 32, 1},
-	{ PJ_SOCK_DGRAM, "udp", 1, 32},
-	{ PJ_SOCK_DGRAM, "udp", 1, 32},
-	{ PJ_SOCK_DGRAM, "udp", 1, 32},
-	{ PJ_SOCK_DGRAM, "udp", 1, 32},
-	{ PJ_SOCK_STREAM, "tcp", 32, 1},
-	{ PJ_SOCK_STREAM, "tcp", 32, 1},
-	{ PJ_SOCK_STREAM, "tcp", 32, 1},
-	{ PJ_SOCK_STREAM, "tcp", 32, 1},
-	{ PJ_SOCK_STREAM, "tcp", 1, 32},
-	{ PJ_SOCK_STREAM, "tcp", 1, 32},
-	{ PJ_SOCK_STREAM, "tcp", 1, 32},
-	{ PJ_SOCK_STREAM, "tcp", 1, 32},
+	{ SOCK_DGRAM, "udp", 32, 1},
+	{ SOCK_DGRAM, "udp", 32, 1},
+	{ SOCK_DGRAM, "udp", 32, 1},
+	{ SOCK_DGRAM, "udp", 32, 1},
+	{ SOCK_DGRAM, "udp", 1, 32},
+	{ SOCK_DGRAM, "udp", 1, 32},
+	{ SOCK_DGRAM, "udp", 1, 32},
+	{ SOCK_DGRAM, "udp", 1, 32},
+	{ SOCK_STREAM, "tcp", 32, 1},
+	{ SOCK_STREAM, "tcp", 32, 1},
+	{ SOCK_STREAM, "tcp", 32, 1},
+	{ SOCK_STREAM, "tcp", 32, 1},
+	{ SOCK_STREAM, "tcp", 1, 32},
+	{ SOCK_STREAM, "tcp", 1, 32},
+	{ SOCK_STREAM, "tcp", 1, 32},
+	{ SOCK_STREAM, "tcp", 1, 32},
 */
     };
@@ -503,4 +513,11 @@
     PJ_LOG(3,(THIS_FILE, "   Type  Threads  Skt.Pairs      Bandwidth"));
     PJ_LOG(3,(THIS_FILE, "   ======================================="));
+
+    for (i=0; i<PJ_ARRAY_SIZE(test_param); ++i) {
+	if (test_param[i].type == SOCK_DGRAM)
+	    test_param[i].type = PJ_SOCK_DGRAM;
+	else if (test_param[i].type == SOCK_STREAM)
+	    test_param[i].type = PJ_SOCK_STREAM;
+    }
 
     best_bandwidth = 0;
Index: /pjproject/branches/symbian/pjlib/src/pjlib-test/ioq_tcp.c
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pjlib-test/ioq_tcp.c	(revision 787)
+++ /pjproject/branches/symbian/pjlib/src/pjlib-test/ioq_tcp.c	(revision 788)
@@ -34,5 +34,12 @@
 #if INCLUDE_TCP_IOQUEUE_TEST
 
-#include <pjlib.h>
+#include <pj/assert.h>
+#include <pj/errno.h>
+#include <pj/ioqueue.h>
+#include <pj/log.h>
+#include <pj/pool.h>
+#include <pj/sock.h>
+#include <pj/string.h>
+
 
 #if PJ_HAS_TCP
Index: /pjproject/branches/symbian/pjlib/src/pjlib-test/ioq_udp.c
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pjlib-test/ioq_udp.c	(revision 787)
+++ /pjproject/branches/symbian/pjlib/src/pjlib-test/ioq_udp.c	(revision 788)
@@ -35,5 +35,13 @@
 #if INCLUDE_UDP_IOQUEUE_TEST
 
-#include <pjlib.h>
+#include <pj/assert.h>
+#include <pj/errno.h>
+#include <pj/ioqueue.h>
+#include <pj/log.h>
+#include <pj/os.h>
+#include <pj/pool.h>
+#include <pj/sock.h>
+#include <pj/string.h>
+
 
 #include <pj/compat/socket.h>
@@ -329,5 +337,5 @@
                              pj_ssize_t bytes_read)
 {
-    unsigned *p_packet_cnt = pj_ioqueue_get_user_data(key);
+    unsigned *p_packet_cnt = (unsigned *)pj_ioqueue_get_user_data(key);
 
     PJ_UNUSED_ARG(op_key);
@@ -511,6 +519,6 @@
 	return PJ_ENOMEM;
 
-    key = pj_pool_alloc(pool, MAX*sizeof(pj_ioqueue_key_t*));
-    sock = pj_pool_alloc(pool, MAX*sizeof(pj_sock_t));
+    key = (pj_ioqueue_key_t **)pj_pool_alloc(pool, MAX*sizeof(pj_ioqueue_key_t*));
+    sock = (pj_sock_t *)pj_pool_alloc(pool, MAX*sizeof(pj_sock_t));
     
     /* Create IOQueue */
Index: /pjproject/branches/symbian/pjlib/src/pjlib-test/main_symbian.cpp
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pjlib-test/main_symbian.cpp	(revision 787)
+++ /pjproject/branches/symbian/pjlib/src/pjlib-test/main_symbian.cpp	(revision 788)
@@ -7,4 +7,29 @@
 
 #include "test.h"
+#include <stdlib.h>
+#include <pj/errno.h>
+#include <pj/os.h>
+#include <pj/log.h>
+#include <pj/unicode.h>
+#include <stdio.h>
+
+#include <e32std.h>
+
+#if 0
+int main()
+{
+    int err = 0;
+    int exp = 0;
+
+    err = test_main();
+    //err = test_main();
+
+    if (err)
+	return err;
+    return exp;
+    //return 0;
+}
+
+#else
 #include <pj/os.h>
 
@@ -13,10 +38,4 @@
 #include <e32cons.h>            // Console
 
-
-//  Constants
-
-_LIT(KTextConsoleTitle, "Console");
-_LIT(KTextFailed, " failed, leave code = %d");
-_LIT(KTextPressAnyKey, " [press any key]\n");
 
 
@@ -29,10 +48,85 @@
 
 LOCAL_C void MainL()
-    {
+{
     //
     // add your program code here, example code below
     //
     test_main();
-    }
+    CActiveScheduler::Stop();
+}
+
+class MyScheduler : public CActiveScheduler
+{
+public:
+    MyScheduler()
+    {}
+
+    void Error(TInt aError) const;
+};
+
+void MyScheduler::Error(TInt aError) const
+{
+    int i = 0;
+}
+
+class ProgramStarter : public CActive
+{
+public:
+    static ProgramStarter *NewL();
+    void Start();
+
+protected:
+    ProgramStarter();
+    void ConstructL();
+    virtual void RunL();
+    virtual void DoCancel();
+    TInt RunError(TInt aError);
+
+private:
+    RTimer timer_;
+};
+
+ProgramStarter::ProgramStarter()
+: CActive(EPriorityNormal)
+{
+}
+
+void ProgramStarter::ConstructL()
+{
+    timer_.CreateLocal();
+    CActiveScheduler::Add(this);
+}
+
+ProgramStarter *ProgramStarter::NewL()
+{
+    ProgramStarter *self = new (ELeave) ProgramStarter;
+    CleanupStack::PushL(self);
+
+    self->ConstructL();
+
+    CleanupStack::Pop(self);
+    return self;
+}
+
+void ProgramStarter::Start()
+{
+    timer_.After(iStatus, 0);
+    SetActive();
+}
+
+void ProgramStarter::RunL()
+{
+    MainL();
+}
+
+void ProgramStarter::DoCancel()
+{
+}
+
+TInt ProgramStarter::RunError(TInt aError)
+{
+    PJ_UNUSED_ARG(aError);
+    return KErrNone;
+}
 
 
@@ -40,16 +134,32 @@
     {
     // Create active scheduler (to run active objects)
-    CActiveScheduler* scheduler = new (ELeave) CActiveScheduler();
+    CActiveScheduler* scheduler = new (ELeave) MyScheduler;
     CleanupStack::PushL(scheduler);
     CActiveScheduler::Install(scheduler);
 
-    MainL();
+    ProgramStarter *starter = ProgramStarter::NewL();
+    starter->Start();
+
+    CActiveScheduler::Start();
 
     // Delete active scheduler
-    CleanupStack::PopAndDestroy(scheduler);
+    //CActiveScheduler::Install(NULL);
+    scheduler->Stop();
+    //delete scheduler;
     }
 
 
 //  Global Functions
+
+static void log_writer(int level, const char *buf, int len)
+{
+    wchar_t buf16[PJ_LOG_MAX_SIZE];
+
+    pj_ansi_to_unicode(buf, len, buf16, PJ_ARRAY_SIZE(buf16));
+
+    TPtrC16 aBuf((const TUint16*)buf16, (TInt)len);
+    console->Write(aBuf);
+}
+
 
 GLDEF_C TInt E32Main()
@@ -60,13 +170,15 @@
 
     // Create output console
-    TRAPD(createError, console = Console::NewL(KTextConsoleTitle, TSize(KConsFullScreen,KConsFullScreen)));
+    TRAPD(createError, console = Console::NewL(_L("Console"), TSize(KConsFullScreen,KConsFullScreen)));
     if (createError)
         return createError;
+
+    pj_log_set_log_func(&log_writer);
 
     // Run application code inside TRAP harness, wait keypress when terminated
     TRAPD(mainError, DoStartL());
     if (mainError)
-        console->Printf(KTextFailed, mainError);
-    console->Printf(KTextPressAnyKey);
+        console->Printf(_L(" failed, leave code = %d"), mainError);
+    console->Printf(_L(" [press any key]\n"));
     console->Getch();
     
@@ -76,2 +188,5 @@
     return KErrNone;
     }
+
+#endif	/* if 0 */
+
Index: /pjproject/branches/symbian/pjlib/src/pjlib-test/mutex.c
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pjlib-test/mutex.c	(revision 787)
+++ /pjproject/branches/symbian/pjlib/src/pjlib-test/mutex.c	(revision 788)
@@ -18,5 +18,6 @@
  */
 #include "test.h"
-#include <pjlib.h>
+#include <pj/errno.h>
+#include <pj/os.h>
 
 #if INCLUDE_MUTEX_TEST
Index: /pjproject/branches/symbian/pjlib/src/pjlib-test/rand.c
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pjlib-test/rand.c	(revision 787)
+++ /pjproject/branches/symbian/pjlib/src/pjlib-test/rand.c	(revision 788)
@@ -23,5 +23,10 @@
 #if INCLUDE_RAND_TEST
 
-#define COUNT  1024
+#if defined(PJ_SYMBIAN) && PJ_SYMBIAN!=0
+#   define COUNT    128
+#else
+#   define COUNT  1024
+#endif
+
 static int values[COUNT];
 
Index: /pjproject/branches/symbian/pjlib/src/pjlib-test/select.c
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pjlib-test/select.c	(revision 787)
+++ /pjproject/branches/symbian/pjlib/src/pjlib-test/select.c	(revision 788)
@@ -72,5 +72,5 @@
     }
 
-    timeout.sec = 1;
+    timeout.sec = 5;
     timeout.msec = 0;
 
Index: /pjproject/branches/symbian/pjlib/src/pjlib-test/sock.c
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pjlib-test/sock.c	(revision 787)
+++ /pjproject/branches/symbian/pjlib/src/pjlib-test/sock.c	(revision 788)
@@ -17,5 +17,9 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
  */
-#include <pjlib.h>
+#include <pj/errno.h>
+#include <pj/ioqueue.h>
+#include <pj/log.h>
+#include <pj/sock.h>
+#include <pj/string.h>
 #include "test.h"
 
@@ -65,8 +69,4 @@
 #define BIG_DATA_LEN	9000
 #define ADDRESS		"127.0.0.1"
-#define A0		127
-#define A1		0
-#define A2		0
-#define A3		1
 
 
@@ -80,4 +80,10 @@
     pj_in_addr addr;
     const pj_str_t *hostname;
+#if defined(PJ_SYMBIAN) && PJ_SYMBIAN!=0
+    /* Symbian IP address is saved in host order */
+    unsigned char A[] = {1, 0, 0, 127};
+#else
+    unsigned char A[] = {127, 0, 0, 1};
+#endif
 
     PJ_LOG(3,("test", "...format_test()"));
@@ -89,5 +95,5 @@
     /* Check the result. */
     p = (unsigned char*)&addr;
-    if (p[0]!=A0 || p[1]!=A1 || p[2]!=A2 || p[3]!=A3) {
+    if (p[0]!=A[0] || p[1]!=A[1] || p[2]!=A[2] || p[3]!=A[3]) {
 	PJ_LOG(3,("test", "  error: mismatched address. p0=%d, p1=%d, "
 			  "p2=%d, p3=%d", p[0] & 0xFF, p[1] & 0xFF, 
@@ -97,9 +103,9 @@
 
     /* pj_inet_ntoa() */
-    p = pj_inet_ntoa(addr);
+    p = (unsigned char*)pj_inet_ntoa(addr);
     if (!p)
 	return -20;
 
-    if (pj_strcmp2(&s, p) != 0)
+    if (pj_strcmp2(&s, (char*)p) != 0)
 	return -30;
 
Index: /pjproject/branches/symbian/pjlib/src/pjlib-test/sock_perf.c
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pjlib-test/sock_perf.c	(revision 787)
+++ /pjproject/branches/symbian/pjlib/src/pjlib-test/sock_perf.c	(revision 788)
@@ -18,5 +18,10 @@
  */
 #include "test.h"
-#include <pjlib.h>
+#include <pj/errno.h>
+#include <pj/ioqueue.h>
+#include <pj/log.h>
+#include <pj/os.h>
+#include <pj/pool.h>
+#include <pj/sock.h>
 #include <pj/compat/high_precision.h>
 
@@ -70,6 +75,6 @@
 
     /* Create buffers. */
-    outgoing_buffer = pj_pool_alloc(pool, buf_size);
-    incoming_buffer = pj_pool_alloc(pool, buf_size);
+    outgoing_buffer = (char*)pj_pool_alloc(pool, buf_size);
+    incoming_buffer = (char*)pj_pool_alloc(pool, buf_size);
 
     /* Start loop. */
Index: /pjproject/branches/symbian/pjlib/src/pjlib-test/string_test.c
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pjlib-test/string_test.c	(revision 787)
+++ /pjproject/branches/symbian/pjlib/src/pjlib-test/string_test.c	(revision 788)
@@ -284,6 +284,6 @@
 int string_test(void)
 {
-    const pj_str_t hello_world = { HELLO_WORLD, strlen(HELLO_WORLD) };
-    const pj_str_t just_hello = { JUST_HELLO, strlen(JUST_HELLO) };
+    pj_str_t hello_world;
+    pj_str_t just_hello;
     pj_str_t s1, s2, s3, s4, s5;
     enum { RCOUNT = 10, RLEN = 16 };
@@ -291,4 +291,7 @@
     pj_pool_t *pool;
     int i;
+
+    hello_world = pj_str(HELLO_WORLD);
+    just_hello = pj_str(JUST_HELLO);
 
     pool = pj_pool_create(mem, NULL, 4096, 0, NULL);
@@ -328,5 +331,5 @@
      * pj_strcpy(), pj_strcat() 
      */
-    s3.ptr = pj_pool_alloc(pool, 256);
+    s3.ptr = (char*)pj_pool_alloc(pool, 256);
     if (!s3.ptr) 
 	return -200;
@@ -348,5 +351,5 @@
      * pj_utoa() 
      */
-    s5.ptr = pj_pool_alloc(pool, 16);
+    s5.ptr = (char*)pj_pool_alloc(pool, 16);
     if (!s5.ptr)
 	return -270;
@@ -366,5 +369,5 @@
 	int j;
 	
-	random[i].ptr = pj_pool_alloc(pool, RLEN);
+	random[i].ptr = (char*)pj_pool_alloc(pool, RLEN);
 	if (!random[i].ptr)
 	    return -320;
Index: /pjproject/branches/symbian/pjlib/src/pjlib-test/test.c
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pjlib-test/test.c	(revision 787)
+++ /pjproject/branches/symbian/pjlib/src/pjlib-test/test.c	(revision 788)
@@ -18,5 +18,11 @@
  */
 #include "test.h"
-#include <pjlib.h>
+#include <pj/errno.h>
+#include <pj/ioqueue.h>
+#include <pj/log.h>
+#include <pj/os.h>
+#include <pj/pool.h>
+#include <pj/sock.h>
+
 #ifdef _MSC_VER
 #  pragma warning(disable:4127)
@@ -195,16 +201,4 @@
 int test_main(void)
 {
-    PJ_USE_EXCEPTION;
-
-    PJ_TRY {
-        return test_inner();
-    }
-    PJ_CATCH_ANY {
-        int id = PJ_GET_EXCEPTION();
-        PJ_LOG(3,("test", "FATAL: unhandled exception id %d (%s)", 
-                  id, pj_exception_id_name(id)));
-    }
-    PJ_END;
-
-    return -1;
+    return test_inner();
 }
Index: /pjproject/branches/symbian/pjlib/src/pjlib-test/test.h
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pjlib-test/test.h	(revision 787)
+++ /pjproject/branches/symbian/pjlib/src/pjlib-test/test.h	(revision 788)
@@ -25,8 +25,8 @@
 #define GROUP_OS                    0
 #define GROUP_DATA_STRUCTURE        0
-#define GROUP_NETWORK               0
+#define GROUP_NETWORK               1
 #define GROUP_FILE                  0
 
-#define INCLUDE_ERRNO_TEST          GROUP_LIBC
+#define INCLUDE_ERRNO_TEST          0	// GROUP_LIBC
 #define INCLUDE_TIMESTAMP_TEST      GROUP_OS
 #define INCLUDE_EXCEPTION_TEST	    GROUP_LIBC
@@ -34,16 +34,16 @@
 #define INCLUDE_LIST_TEST	    GROUP_DATA_STRUCTURE
 #define INCLUDE_POOL_TEST	    GROUP_LIBC
-#define INCLUDE_POOL_PERF_TEST	    (PJ_HAS_MALLOC && GROUP_LIBC)
-#define INCLUDE_STRING_TEST	    GROUP_DATA_STRUCTURE
+#define INCLUDE_POOL_PERF_TEST	    0	// (PJ_HAS_MALLOC && GROUP_LIBC)
+#define INCLUDE_STRING_TEST	    0	// GROUP_DATA_STRUCTURE
 #define INCLUDE_FIFOBUF_TEST	    0	// GROUP_DATA_STRUCTURE
 #define INCLUDE_RBTREE_TEST	    GROUP_DATA_STRUCTURE
 #define INCLUDE_TIMER_TEST	    GROUP_DATA_STRUCTURE
 #define INCLUDE_ATOMIC_TEST         GROUP_OS
-#define INCLUDE_MUTEX_TEST	    GROUP_OS
+#define INCLUDE_MUTEX_TEST	    (PJ_HAS_THREADS && GROUP_OS)
 #define INCLUDE_SLEEP_TEST          GROUP_OS
-#define INCLUDE_THREAD_TEST         GROUP_OS
-#define INCLUDE_SOCK_TEST	    GROUP_NETWORK
-#define INCLUDE_SOCK_PERF_TEST      GROUP_NETWORK
-#define INCLUDE_SELECT_TEST	    GROUP_NETWORK
+#define INCLUDE_THREAD_TEST         (PJ_HAS_THREADS && GROUP_OS)
+#define INCLUDE_SOCK_TEST	    0 	// GROUP_NETWORK
+#define INCLUDE_SOCK_PERF_TEST      0	// GROUP_NETWORK
+#define INCLUDE_SELECT_TEST	    0	// GROUP_NETWORK
 #define INCLUDE_UDP_IOQUEUE_TEST    GROUP_NETWORK
 #define INCLUDE_TCP_IOQUEUE_TEST    GROUP_NETWORK
Index: /pjproject/branches/symbian/pjlib/src/pjlib-test/timestamp.c
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pjlib-test/timestamp.c	(revision 787)
+++ /pjproject/branches/symbian/pjlib/src/pjlib-test/timestamp.c	(revision 788)
@@ -196,5 +196,5 @@
     }
 
-    sleep(0);
+    pj_thread_sleep(0);
 
     /* Mark end time. */
Index: /pjproject/branches/symbian/pjlib/src/pjlib-test/udp_echo_srv_ioqueue.c
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pjlib-test/udp_echo_srv_ioqueue.c	(revision 787)
+++ /pjproject/branches/symbian/pjlib/src/pjlib-test/udp_echo_srv_ioqueue.c	(revision 788)
@@ -17,5 +17,8 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
  */
-#include <pjlib.h>
+#include <pj/errno.h>
+#include <pj/ioqueue.h>
+#include <pj/pool.h>
+#include <pj/sock.h>
 #include "test.h"
 
@@ -118,5 +121,5 @@
 static int worker_thread(void *arg)
 {
-    pj_ioqueue_t *ioqueue = arg;
+    pj_ioqueue_t *ioqueue = (pj_ioqueue_t *)arg;
     struct op_key read_op, write_op;
     char recv_buf[512], send_buf[512];
Index: /pjproject/branches/symbian/pjlib/src/pjlib-test/udp_echo_srv_sync.c
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pjlib-test/udp_echo_srv_sync.c	(revision 787)
+++ /pjproject/branches/symbian/pjlib/src/pjlib-test/udp_echo_srv_sync.c	(revision 788)
@@ -18,5 +18,11 @@
  */
 #include "test.h"
-#include <pjlib.h>
+#include <pj/errno.h>
+#include <pj/ioqueue.h>
+#include <pj/os.h>
+#include <pj/pool.h>
+#include <pj/sock.h>
+#include <pj/compat/high_precision.h>
+
 
 static pj_atomic_t *total_bytes;
Index: /pjproject/branches/symbian/pjlib/src/pjlib-test/util.c
===================================================================
--- /pjproject/branches/symbian/pjlib/src/pjlib-test/util.c	(revision 787)
+++ /pjproject/branches/symbian/pjlib/src/pjlib-test/util.c	(revision 788)
@@ -18,5 +18,10 @@
  */
 #include "test.h"
-#include <pjlib.h>
+#include <pj/errno.h>
+#include <pj/log.h>
+#include <pj/os.h>
+#include <pj/sock.h>
+#include <pj/string.h>
+
 
 #define THIS_FILE "util.c"
Index: /pjproject/branches/symbian/symbian/b.bat
===================================================================
--- /pjproject/branches/symbian/symbian/b.bat	(revision 787)
+++ /pjproject/branches/symbian/symbian/b.bat	(revision 788)
@@ -1,4 +1,7 @@
 rem set MWSym2Libraries=1
 rem set MWSym2Libraries=\Symbian\9.1\S60_3rd\Epoc32\release\winscw\udeb
-set EPOCROOT=\Symbian\9.1\S60_3rd\
-abld build -v winscw udeb
+rem set EPOCROOT=\Symbian\9.1\S60_3rd\
+rem call abld build -v winscw udeb
+
+set EPOCROOT=\Symbian\UIQ3SDK\
+call abld build -v vs6 udeb
Index: /pjproject/branches/symbian/symbian/bld.inf
===================================================================
--- /pjproject/branches/symbian/symbian/bld.inf	(revision 787)
+++ /pjproject/branches/symbian/symbian/bld.inf	(revision 788)
@@ -1,3 +1,3 @@
 prj_mmpfiles
 pjlib.mmp
-pjlib-test.mmp
+pjlib_test.mmp
Index: /pjproject/branches/symbian/symbian/pjlib.mmp
===================================================================
--- /pjproject/branches/symbian/symbian/pjlib.mmp	(revision 787)
+++ /pjproject/branches/symbian/symbian/pjlib.mmp	(revision 788)
@@ -1,3 +1,3 @@
-TARGET 		pjlib-symbian.lib
+TARGET 		pjlib.lib
 TARGETTYPE 	lib
 UID		0x100039CE 0x10004299
@@ -17,5 +17,4 @@
 SOURCE		ctype.c
 SOURCE		errno.c
-SOURCE		except.c
 SOURCE		fifobuf.c
 SOURCE		guid.c
@@ -37,24 +36,24 @@
 // Platform dependent source
 //
-SOURCE		addr_resolv_sock.c
+SOURCE		addr_resolv_symbian.cpp
+SOURCE		exception_symbian.cpp
 SOURCE		file_access_unistd.c
 SOURCE		file_io_ansi.c
 SOURCE		guid_simple.c
-SOURCE		log_writer_stdout.c
+SOURCE		log_writer_symbian_console.cpp
 SOURCE		os_core_symbian.cpp
-SOURCE		os_error_unix.c
+SOURCE		os_error_symbian.cpp
+SOURCE		os_timestamp_common.c
 SOURCE		os_time_unix.c
-SOURCE		os_timestamp_common.c
 SOURCE		os_timestamp_posix.c
-SOURCE		pool_policy_malloc.c
+SOURCE		pool_policy_new.cpp
 SOURCE		compat\string_compat.c
-SOURCE		sock_bsd.c
+SOURCE		sock_symbian.cpp
 SOURCE		sock_select_symbian.cpp
 SOURCE		ioqueue_symbian.cpp
+SOURCE		unicode_symbian.cpp
 
 
 SYSTEMINCLUDE	..\pjlib\include
-//SYSTEMINCLUDE	\symbian\9.1\S60_3rd_MR\epoc32\include
-//SYSTEMINCLUDE	\symbian\9.1\S60_3rd_MR\epoc32\include\libc
-SYSTEMINCLUDE	\symbian\9.1\S60_3rd\epoc32\include
-SYSTEMINCLUDE	\symbian\9.1\S60_3rd\epoc32\include\libc
+SYSTEMINCLUDE	\epoc32\include
+SYSTEMINCLUDE	\epoc32\include\libc
Index: /pjproject/branches/symbian/symbian/pjlib_test.mmp
===================================================================
--- /pjproject/branches/symbian/symbian/pjlib_test.mmp	(revision 788)
+++ /pjproject/branches/symbian/symbian/pjlib_test.mmp	(revision 788)
@@ -0,0 +1,58 @@
+TARGET 		pjlib_test.exe
+TARGETTYPE 	exe
+UID		0x100039CE 0x10004299
+VENDORID	0x70000001
+
+SOURCEPATH	..\pjlib\src\pjlib-test
+
+MACRO		PJ_M_I386=1
+MACRO		PJ_SYMBIAN=1
+MACRO		PJ_IMPORTING
+
+
+// Test files
+
+SOURCE	atomic.c
+SOURCE	echo_clt.c
+SOURCE	errno.c
+SOURCE	exception.c
+SOURCE	fifobuf.c
+SOURCE	file.c
+SOURCE	ioq_perf.c
+SOURCE	ioq_tcp.c
+SOURCE	ioq_udp.c
+SOURCE	ioq_unreg.c
+SOURCE	list.c
+SOURCE	mutex.c
+SOURCE	os.c
+SOURCE	pool.c
+SOURCE	pool_perf.c
+SOURCE	rand.c
+SOURCE	rbtree.c
+SOURCE	select.c
+SOURCE	sleep.c
+SOURCE	sock.c
+SOURCE	sock_perf.c
+SOURCE	string_test.c
+SOURCE	test.c
+SOURCE	thread.c
+SOURCE	timer.c
+SOURCE	timestamp.c
+SOURCE	udp_echo_srv_ioqueue.c
+SOURCE	udp_echo_srv_sync.c
+SOURCE	util.c
+
+SOURCE	main_symbian.cpp
+//SOURCE	main.c
+
+
+SYSTEMINCLUDE	..\pjlib\include
+SYSTEMINCLUDE	\epoc32\include
+SYSTEMINCLUDE	\epoc32\include\libc
+//SYSTEMINCLUDE	\symbian\9.1\S60_3rd_MR\epoc32\include
+//SYSTEMINCLUDE	\symbian\9.1\S60_3rd_MR\epoc32\include\libc
+
+LIBRARY		pjlib.lib esock.lib insock.lib charconv.lib euser.lib estlib.lib eexe.lib
+STATICLIBRARY   ecrt0.lib
+CAPABILITY	None
+
Index: /pjproject/branches/symbian/symbian/s.bat
===================================================================
--- /pjproject/branches/symbian/symbian/s.bat	(revision 787)
+++ /pjproject/branches/symbian/symbian/s.bat	(revision 788)
@@ -1,4 +1,5 @@
 rem set MWSym2Libraries=1
-set EPOCROOT=\Symbian\9.1\S60_3rd\
+rem set EPOCROOT=\Symbian\9.1\S60_3rd\
+set EPOCROOT=\Symbian\UIQ3SDK\
 bldmake bldfiles
 call b.bat
